*****************************************************************************
** Shade Bob Fast  1995 Captain Xenon
** ----------------------------------------
** version 1.01 (17/3-95)
*****************************************************************************
** This is a hell of a shadebob routine. You can have up to 23 (32*32)
** ShadeBobs in one frame when using "BLITTER NASTY".
*****************************************************************************

Execbase        equ 4
Openlib         equ -552
Closelib        equ -414
Forbid          equ -132
Permit          equ -138
SuperState	equ -150
UserState	equ -156

SpeedTest	equ 0	; 1=Test

Version         equ 33		; Minimum library version
NumberOfPlanes  equ 5

ScreenWide	equ 48
ScreenTall	equ 256
ScreenSize      equ ScreenWide*ScreenTall

BobWide		equ 4+2		; in bytes (plus 1 word for shift)
BobTall		equ 31		; in pixels

		include	MyInclude/My_Hardware.i

                section main,code_c

_Start:         movem.l	a0-a6/d0-d7,-(a7)	; save old registers to stack
		move.l	a7,OldStack		; save stack

		bsr.s   GrabSys                 ; Get sys copper etc...
                beq.s   Exit                    ; Exit if library failed
                bsr.w	ClearScreen
		bsr.w	SetUpMouse
		bsr.w	MakeYMulTable
		bsr.w   SetUpScreen             ; Set up bitplanes
		bsr.w   StrtCop                 ; Start DMA
		bsr.w   SetUpL3Vbl              ; Start interrupt
*--------------------------------

WaitMouse:      btst.b	#6,$bfe001
                bne.s   WaitMouse
                
		tst.b	(a6)			; Agnus bug
.WaitBlit	btst.b	#14-8,DMACONR(a6)
		bne.s	.WaitBlit

*--------------------------------       
Tidyup:         bsr.w   RestoreInts             ; Restore interrupt vector(s)
                bsr.w   RestoreDMA              ; Restore original DMA & Copper
	        bsr.w   RestoreSys              ; Allow task-switching

Exit:         	move.l	OldStack(pc),a7		; restore old stack ptr
		movem.l	(a7)+,a0-a6/d0-d7	; restore old regs from stack
		moveq	#0,d0			; no cli return code for us!
		rts 

*******************************************************************************
** Open graphics.library and get system copper pointer.                      **
** Store DMACon/Interrupt status/Audio & Disk controller status and init 'em **
** Force NTSC machines to PAL (This may cause trouble with NTSC televisions) **
*******************************************************************************

GrabSys:        move.l  (Execbase).w,a6
                lea     Gfxname(pc),a1
                moveq   #Version,d0
                jsr     Openlib(a6)	        ; Open graphics.library
                beq.s   .GrabsysFin
                move.l  d0,a1
                move.l  38(a1),Oldcopper        ; Store system copperlist
                jsr     Closelib(a6)            ; Close graphics.library

		jsr     Forbid(a6)              ; Stop task-switching

		jsr	SuperState(a6)		; goto superstate (OS Friendly)
		move.l	d0,SysStack		; save old system stack

*-------------------------------- 
		lea	CUSTOM,a6

		move.w	#$8000,d0
		lea     Hardware(pc),a0
                move.w  DMACONR(a6),(a0)        ; Store DMA
                or.w    d0,(a0)+                ; Set top bit
                move.w  INTENAR(a6),(a0)        ; Store System interrupts
                or.w    d0,(a0)+
                move.w  INTREQR(a6),(a0)        ; Store Interrupt requester
                or.w    d0,(a0)+
                move.w  ADKCONR(a6),(a0)        ; Store Audio&Disk controller
                or.w    d0,(a0)
		move.w	#$7fff,d0		; Kill value
		move.w  d0,DMACON(a6)           ; Kill DMA
                move.w  d0,INTENA(a6)           ; Disable interrupts
                move.w	d0,INTREQ(a6)
		move.w  d0,ADKCON(a6)           ; Stop sound channels/disk

*--------------------------------       
                move.w  #$20,BEAMCON0(a6)       ; Force NTSC to PAL
                moveq   #1,d0	                ; Make d0 non-zero: no error
.GrabsysFin     rts

*******************************************************************************
** Set up bitplanes for screen.                                              **
*******************************************************************************

SetUpScreen:    lea     Bpls+2(pc),a0             ; Point to bitplane pointers
		move.l	#Screen,d0	        ; Point to screen data
                moveq	#NumberOfPlanes-1,d1
.SetScr         move.w  d0,4(a0)                ; LS Word into BPLxPTL
                swap    d0
                move.w  d0,(a0)                ; MS Word into BPLxPTH
                swap    d0
                add.l	#ScreenSize,d0          ; Point to data for next plane
                addq.w  #8,a0
                dbf     d1,.SetScr
                rts

*****************************************************************************
** Clear Screen
*****************************************************************************

ClearScreen:	lea	Screen,a0
		move.w	#((ScreenSize*NumberOfPlanes)/16)-1,d0
		moveq	#0,d1
.ClearLoop	move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		move.l	d1,(a0)+
		dbf	d0,.ClearLoop
		rts

*****************************************************************************
** Move new copperlist in and start it
*****************************************************************************

StrtCop:        move.l  #MyCopper,COP1LCH(a6)
                move.w  d0,COPJMP1(a6)          ; Start copper
                move.w  #$87c0,DMACON(a6)       ; Enable required DMA
                rts

*****************************************************************************
** Set up a level 3 Vbl interrupt
*****************************************************************************

SetUpL3Vbl:     move.l  $6c.w,Vector            ; Store original vector
                move.l  #Lvl3Irq,$6c.w          ; Move in pointer to new subr
                move.w	#$C020,INTENA(a6)	; Enable Level 3 vbl interrupt
		rts

*****************************************************************************
** Stop interrupts and restore original vectors.
** Only needed if using interrupts.
*****************************************************************************

RestoreInts:    move.w  #$7fff,DMACON(a6)       ; Disable interrupts
                move.w  #$7fff,INTENA(a6)
                move.l  Vector(pc),$6c.w
                rts

*****************************************************************************
** Restore copperlist and saved DMA/Interrupts/Disk controller status
*****************************************************************************

RestoreDMA:     move.l  Oldcopper(pc),COP1LCH(a6)
                move.w  d0,COPJMP1(a6)          ; Restore system copper
                lea     Hardware(pc),a1 
                move.w  (a1)+,DMACON(a6)        ; Restore system DMA
                move.w  (a1)+,INTENA(a6)        ; Restore system interrupts
                move.w  (a1)+,INTREQ(a6)        ; and requsters
                move.w  (a1),ADKCON(a6)         ; Restore disk-controller state
                rts

*******************************************************************************
** Enable task-switching and clear DOS error return code                     **
*******************************************************************************

RestoreSys:     move.l  (Execbase).w,a6
                move.l	SysStack(pc),d0		; old system stack in d0
		jsr	UserState(a6)		; go back into userstate
		jsr     Permit(a6)              ; Enable task-switching
                rts

*******************************************************************************
** Level 3 Vbl interrupt handler. Detects for Vertical-blank interrupt ONLY. **
*******************************************************************************

Lvl3Irq:        movem.l d0-d7/a0-a6,-(sp)
                move.w  INTREQR(a6),d0		; Make sure it's a level 3 Vbl
                and.w	#$0020,d0               ; that's happening...
                beq.s   .Lvl3Out                ; If not, return
                
		bsr.s	TrackMouse
		bsr.w	MakeShade

		IFNE	SpeedTest
		move.w	#$0fff,$dff180		; test speed of routine
		ENDC

.Lvl3Ackit      move.w  #$0020,INTREQ(a6)       ; Acknowledge interrupt
.Lvl3Out        movem.l (sp)+,d0-d7/a0-a6
                rte                             ; Return

*****************
** Track Mouse **
*****************

TrackMouse:	move.w	JOY0DAT(a6),d0	; Register for Mouse port
		move.b	OldX(pc),d1	;
		move.b	d0,OldX		;
		sub.b	d0,d1		; Calc X Position of Mouse
		ext.w	d1		;
		sub.w	d1,XPos		;
	
		tst.w	XPos		; Test for X Position 0
		bpl.s	.X2		; if less than 0 (off Screen)
		move.w	#0,XPos		; then put back to 0
	
.X2		cmp.w	#(ScreenWide*8)-(BobWide*8)-6*8,XPos
					; Test X MaxPos
		ble.s	.YPos		; if greater, then off screen
		move.w	#(ScreenWide*8)-(BobWide*8)-6*8,XPos
					; put down to MaxPos

.YPos		lsr.w	#8,d0		; Get Y Pos Data
		move.b	OldY(pc),d1	;
		move.b	d0,OldY		;
		sub.b	d0,d1		; Calc Y Position of Mouse
		ext.w	d1		;
		sub.w	d1,YPos		;
	
		tst.w	YPos		; Test for Y Position 0
		bpl.s	.Y2		; if less than 0 (off Screen)
		move.w	#0,YPos		; put back to 0
		
.Y2		cmp.w	#ScreenTall-BobTall,YPos	; Test Y MaxPos
		ble.s	.Quit			; if greater, then off screen
		move.w	#ScreenTall-BobTall,YPos	; put down to MaxPos
.Quit		rts

*****************************************************************************
** Make Shade: Den raskeste shadebob rutina som noen gang er laget med en
** 	       vanlig AMIGA.
*****************************************************************************
** Rutina bygger p det binarie systemet som er slik at hvis du skal legge
** til en s kan du gjre det slik: Ta og forandre frste bit (eor med 1).
** Blir den 1 s stopp, blir den null s fortsett. Slik gjr du helt
** til det ikke er flere biter eller at en bit blir 1.
**
** S kom jeg p en llvorlig ide nr jeg fant ut hvordan du skulle bruke
** blitteren til EOR. Da tar jeg og EOR'er frste bitplane med masken. S
** lager jeg en ny mask der jeg masker bort de bitene som ble 1. Slik
** gjr jeg med alle planene.
*****************************************************************************
** Denne rutina er optimiza s jeg lager ikke en ny mask for hvert plane.
** Jeg bruker isteden en kombinasjon av mask og NOT av det planet jeg ikke
** har laget mask av. Jeg sparer to blit, men siden jeg bruker C channel i
** noen av blittene, s blir denne rutina like rask som om jeg skulle brukt
** 1 mindre blitt i den uoptimiza rutina.
*****************************************************************************

MakeShade:	move.w	XPos(pc),d0
		moveq	#$f,d7		; Mask for shift
		and.b	d0,d7		; d7=Shift value
		lsr.w	#3,d0		; /8
		and.b	#$fe,d0		; Word Pos
		
		move.w	YPos(pc),d1
		lea	YMulTable(pc),a0
		add.w	d1,d1
		move.w	(a0,d1.w),d1	; d1=YPos*ScreenWide
		add.w	d0,d1		; d1=BlitPos

		lea	Screen,a0
		add.w	d1,a0		; BlitPos
		lea	BobData(pc),a1
		lea	MaskBuffer(pc),a2
		
		ror.w	#4,d7		; Shift it to right pos

		moveq	#0,d0		; Brukes til  rense registrer
		moveq	#ScreenWide-BobWide,d1	; BLTXMOD
		move.w	#(BobTall<<6)+(BobWide/2),d2 ; BLTSIZE
					;                     _   _
		move.w	#$0d3c,d3	; Use: ABD, Miniterm: AB+AB
					;                      _ _  _
		move.w	#$0fb4,d4	; Use: ABCD, Miniterm: ABC+AB+AC
					;                      _ _
		move.w	#$0f04,d5	; Use: ABCD, Miniterm: ABC

; Her EOR'er jeg plane1 med BobData
		
		tst.b	(a6)		; Agnus Bug
.wait		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait

		move.l	a0,BLTAPTH(a6)	; Plane1
		move.l	a1,BLTBPTH(a6)	; BobData
		move.l	a0,BLTDPTH(a6)	; Plane1 (Destination)
		move.w	d3,BLTCON0(a6)	; EOR
		move.w	d7,BLTCON1(a6)
		move.l	#-1,BLTAFWM(a6)	; No mask (hit both masks at once)
		move.w	d0,BLTBMOD(a6)
		move.w	d1,BLTAMOD(a6)	; Clear BMOD, AMOD=ScreenWide-BobWide
		move.w	d1,BLTDMOD(a6)
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)
				
; Her EOR'er jeg plane 2 med NOT(PLANE1) og bruker BobData som mask

		lea	(a0),a3			; Plane1
		lea	ScreenSize(a0),a0	; Plane 2

		tst.b	(a6)		; Agnus Bug
.wait2		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait2

		move.l	a0,BLTAPTH(a6)	; Plane2
		move.l	a1,BLTBPTH(a6)	; BobData
		move.l	a3,BLTCPTH(a6)	; Plane1
		move.l	a0,BLTDPTH(a6)	; Plane2 (Destination)
		move.w	d4,BLTCON0(a6)
		move.w	d1,BLTCMOD(a6)	; ScreenWide-BobWide
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)

; Her AND'er jeg NOT(Plane1)NOT(PLANE2) med BobData slik at alle pixelene
; som ble 1 i plane 1 eller 2 blir utelukket for de neste planene.

		tst.b	(a6)		; Agnus Bug
.wait3		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait3

		move.l	a3,BLTAPTH(a6)	; Plane1
		move.l	a1,BLTBPTH(a6)	; BobData
		move.l	a0,BLTCPTH(a6)	; Plane2
		move.l	a2,BLTDPTH(a6)	; MaskBuff (Destination)
		move.w	d5,BLTCON0(a6)
		move.w	d0,BLTDMOD(a6)	; Clear
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)

; Her EOR'er jeg plane 3 med MaskBuff

		lea	ScreenSize(a0),a0	; Plane 3

		tst.b	(a6)		; Agnus Bug
.wait4		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait4

		move.l	a0,BLTAPTH(a6)	; Screen
		move.l	a2,BLTBPTH(a6)	; MaskBuff
		move.l	a0,BLTDPTH(a6)	; Screen (Destination)
		move.w	d3,BLTCON0(a6)	; EOR
		move.w	d0,BLTCON1(a6)	; Clear
		move.w	d1,BLTDMOD(a6)	; ScreenWide-BobWide
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)

; Her EOR'er jeg plane 4 med NOT(PLANE3) AND'ed med MaskBuff. Jeg kopierer
; tilbake plane 4 der MaskBuff er 0 og der plane 3 er 1.

		lea	(a0),a3			; Plane 3
		lea	ScreenSize(a0),a0	; Plane 4

		tst.b	(a6)		; Agnus Bug
.wait5		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait5

		move.l	a0,BLTAPTH(a6)	; Plane4
		move.l	a2,BLTBPTH(a6)	; MaskBuff
		move.l	a3,BLTCPTH(a6)	; Plane3
		move.l	a0,BLTDPTH(a6)	; Plane4 (Destination)
		move.w	d4,BLTCON0(a6)
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)

; Her AND'er jeg NOT(Plane1)NOT(PLANE2) med MaskBuff slik at alle pixelene
; som ble 1 i plane 4 eller 3 blir utelukket for de neste planene.

		tst.b	(a6)		; Agnus Bug
.wait6		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait6

		move.l	a3,BLTAPTH(a6)	; Plane 3
		move.l	a2,BLTBPTH(a6)	; BobData
		move.l	a0,BLTCPTH(a6)	; Plane 4
		move.l	a2,BLTDPTH(a6)	; MaskBuff (Destination)
		move.w	d5,BLTCON0(a6)
		move.w	d0,BLTDMOD(a6)	; Clear
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)
		
; Her EOR'er jeg plane 5 med MaskBuff

		lea	ScreenSize(a0),a0	; Plane 5

		tst.b	(a6)		; Agnus Bug
.wait7		btst.b	#14-8,DMACONR(a6)
		bne.s	.wait7

		move.l	a0,BLTAPTH(a6)	; Plane5
		move.l	a2,BLTBPTH(a6)	; MaskBuff
		move.l	a0,BLTDPTH(a6)	; Plane5 (Destination)
		move.w	d3,BLTCON0(a6)	; EOR
		move.w	d0,BLTCON1(a6)	; Clear
		move.w	d1,BLTDMOD(a6)	; ScreenWide-BobWide
		move.w	d2,BLTSIZE(a6)	; (BobTall<<6)+(BobWide/2)
		rts

****************************************************************************
** Set Up Mouse:
****************************************************************************

SetUpMouse:	move.w	JOY0DAT(a6),d0	; Set the Mouse Position
		move.b	d0,OldX		;
		lsr.w	#8,d0		;
		move.b	d0,OldY		;
		lea	XPos(pc),a0
		move.w	#152,(a0)+
		move.w	#120,(a0)
		rts

*******************************************************************************
** Make Y MulTable: Regner ut alle multiplikasjoner av ScreenWide*Y, hvor
** Y varierer fra 0-(ScreenHigh-1). Foreks. hvis ScreenHigh er 256, s
** regner rutinen ut multiplikasjon med ScreenWiht fra 0-255 (256 linjer).  
*******************************************************************************

MakeYMulTable:	lea	YMulTable(pc),a0
		move.w	#ScreenTall-1,d0
		moveq	#0,d1
		moveq	#ScreenWide,d2		
.loop		move.w	d1,(a0)+
		add.w	d2,d1
		dbf	d0,.loop
		rts	

*******************************************************************************
** Frame variables
*******************************************************************************

Gfxname:        dc.b "graphics.library",0
		even
Hardware:       ds.w 4
Oldcopper:      ds.l 1
Vector:         ds.l 1
OldStack:	ds.l 1
SysStack:	ds.l 1

XPos:		dc.w 0
YPos:		dc.w 0
OldX:		dc.b 0
OldY:		dc.b 0
		even

*******************************************************************************
** Copperlist
*******************************************************************************

PAL_ENABLE	equ $ffe1fffe
END_COPPER	equ $fffffffe
COPPER_INT	equ $009c8010

*-------------------------------

MyCopper:	dc.w DIWSTRT,$2c81,DIWSTOP,$2cc1
                dc.w DDFSTRT,$0038,DDFSTOP,$00b8
                dc.w BPL1MOD,$0008,BPL2MOD,$0008
                dc.w BPLCON0,$5200,BPLCON1,$0000
                dc.w BPLCON2,$0000,BPLCON3,$0000
		dc.w BPLCON4,$0011,FMODE,$0003

*--------------------------------       

Colors:		include Cols/ShadeBobCol5.col

*--------------------------------

Bpls:           dc.w BPL1PTH,$0000,BPL1PTL,$0000
                dc.w BPL2PTH,$0000,BPL2PTL,$0000
                dc.w BPL3PTH,$0000,BPL3PTL,$0000
                dc.w BPL4PTH,$0000,BPL4PTL,$0000
		dc.w BPL5PTH,$0000,BPL5PTL,$0000

*--------------------------------

                dc.l PAL_ENABLE

		dc.l END_COPPER

*******************************************************************************
** Bob data: 2 words for mask and one for shift.
*******************************************************************************
		even
BobData:	dc.w $000f,$e000,$0
		dc.w $007f,$fc00,$0
		dc.w $01ff,$ff00,$0
		dc.w $03ff,$ff80,$0
		dc.w $07ff,$ffc0,$0
		dc.w $0fff,$ffe0,$0
		dc.w $1fff,$fff0,$0
		dc.w $3fff,$fff8,$0
		dc.w $3fff,$fff8,$0
		dc.w $7fff,$fffc,$0
		dc.w $7fff,$fffc,$0
		dc.w $7fff,$fffc,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $ffff,$fffe,$0
		dc.w $7fff,$fffc,$0
		dc.w $7fff,$fffc,$0
		dc.w $7fff,$fffc,$0
		dc.w $3fff,$fff8,$0
		dc.w $3fff,$fff8,$0
		dc.w $1fff,$fff0,$0
		dc.w $0fff,$ffe0,$0
		dc.w $07ff,$ffc0,$0
		dc.w $03ff,$ff80,$0
		dc.w $01ff,$ff00,$0
		dc.w $007f,$fc00,$0
		dc.w $000f,$e000,$0

MaskBuffer:	dcb.w (2+1)*31,0

YMulTable:	dcb.w ScreenTall,0

*******************************************************************************
** BSS CHIP DATA
*******************************************************************************
		Section	Data,bss_c
		CNOP 0,8
Screen:		ds.b ScreenSize*NumberOfPlanes       

*------------------------------------------------------------------------
		end	;end of code
